(in-package 'user)
(load "/course/cs141/lib/asgn5/prolog.lisp")

; (1)

(setq cave-rules '(
  ((sells-figures kmart))
  ((has-patch-kids kmart))
  ((tourist-trap kmart))
  ((tourist-trap sears))
  ((kludge ivan))
  ((home ivan))
  ((tourist-trap ivan))
  ((flammable ivan))
  ((big alex))
  ((flammable alex))
  ((sells-figures alex))
  ((snacks alex))
  ((home alex))
  ((home martha))
  ((tourist-trap martha))
  ((sells-figures lechmere))
  ((tourist-trap lechmere))
  ((computers lechmere))
  ((snacks lechmere))
  ((home sally))
  ((tourist-trap sally))
  ((kludge sally))
  ((computers ann-hope))
  ((snacks ann-hope))
  ((sells-figures ann-hope))
  ((big ann-hope))
  ((computers store-24))
  ((lisp store-24))
  ((snacks store-24))
))

;> (prolog '((flammable (? x)) (home (? x)) (not(tourist-trap (? x)))) cave-rules)
;((FLAMMABLE ALEX) (HOME ALEX) (NOT (TOURIST-TRAP ALEX)))
;> (prolog '((big (? x)) (computers (? x)) (snacks (? x))) cave-rules)
;((BIG ANN-HOPE) (COMPUTERS ANN-HOPE) (SNACKS ANN-HOPE))
;> (prolog '((sells-figures (? x)) (tourist-trap (? x)) (not(has-patch-kids (? x)))) cave-rules)
;((SELLS-FIGURES LECHMERE) (TOURIST-TRAP LECHMERE)
; (NOT (HAS-PATCH-KIDS LECHMERE)))
;> (prolog '((tourist-trap (? x)) (not (flammable (? x)))) cave-rules)
;((TOURIST-TRAP SALLY) (NOT (FLAMMABLE SALLY)))

; (2)

;leslie is the lost AI
; (a)
(prolog '((aztech (? x)) (aztech (? y)) (aztech (? z)) (parent (? x) (? z)) (parent (? y) (? z))  (not (marriedp (? x) (? y))) (not(same (? x) (? y)))) tribe)
; tested, works.
; answer: LEIA & LUKE

; (b)
(prolog '((aztech (? x)) (aztech (? z)) (parent (? x) (? y)) (parent (? z) (? w)) (not(same (? x) (? z)))  (parent (? k) (? x)) (parent (? k) (? z))) tribe)
; tested, works.
; answer: [JACEN | JANE] & BRENDA

; (c)
(prolog '((aztech (? x)) (aztech (? z)) (parent (? x) (? y)) (parent (? z) (? w)) (not(same (? x) (? z)))  (parent (? k) (? x)) (parent (? k) (? z)) (marriedp (? y) (? w))) tribe)
; this is just 2b with a (marriedp (? child1) (? child2)).
; works and tested
; answer: JACEN & BRENDA

; (d)
(prolog '((aztech (? x)) (aztech (? y)) (disciple (? x) (? y)) (not(marriedp (? x) (? z)))) tribe)
; tested, works.
; I don't understand this; i just did it.  kill me now.  -sds-
; answer: OBI-WAN

; (e)
(prolog '((aztech (? x)) (disciple (? x) (? y)) (not (parent (? x) (? z))) (not (marriedp (? y) (? w))) (disciple (? y) (? v))) tribe)
; tested, works.
; answer: BRENDA

