;; Data used in Assignment 6

(in-package 'user)
(load "/course/cs141/asgn/asgn6/grids.lisp")

;; Use grid0 for testing. It is an empty 3 x 3 grid

(setq grid0 (make-grid 3 3))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GRID 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Set grid1 to be a newly made grid

(setq grid1 (make-grid 10 10))

;; Grid 1 should have the following representation
;;
;; 9 + + + + + + + + + +
;; 8 + + + + + + + + + +
;; 7 + + + X + + + + + +
;; 6 + X + + + + + + + +
;; 5 + + + + + + X + + +
;; 4 + + + + + + + + + +
;; 3 + + + + + + + + + +
;; 2 + + X + + + + + + +
;; 1 + + + + + + + + + +
;; 0 + + + + + + + + + +
;;   0 1 2 3 4 5 6 7 8 9 

;; Place the obstacles in the grid
(set-LOC-occ (GRID-ref grid1 2 2) t)
(set-LOC-occ (GRID-ref grid1 6 5) t)
(set-LOC-occ (GRID-ref grid1 1 6) t)
(set-LOC-occ (GRID-ref grid1 3 7) t)

;; Starting and goal locations for problem 1
(setq start1 (make-coord 1 1))

(setq goal1-1 (make-coord 5 5))
(setq goal1-2 (make-coord 6 6))
	     
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GRID 2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(setq grid2 (make-grid 10 10))

;; Grid 2 should have the following representation
;;
;; 
;; 9 + + + + + + + + + +
;; 8 + + + + + + + + X +
;; 7 + + + X + X + + + +
;; 6 + X + + + + + + + +
;; 5 + + + + + + X + + +
;; 4 X + + + + + + + + +
;; 3 + + + + X + + X + +
;; 2 + + + + + + + + + +
;; 1 + + + + + + X + + +
;; 0 + + + + + + + + + +
;;   0 1 2 3 4 5 6 7 8 9

;; Add obstacles to grid 2
(set-LOC-occ (GRID-ref grid2 6 1) t)
(set-LOC-occ (GRID-ref grid2 4 3) t)
(set-LOC-occ (GRID-ref grid2 7 3) t)
(set-LOC-occ (GRID-ref grid2 0 4) t)
(set-LOC-occ (GRID-ref grid2 6 5) t)
(set-LOC-occ (GRID-ref grid2 1 6) t)
(set-LOC-occ (GRID-ref grid2 3 7) t)
(set-LOC-occ (GRID-ref grid2 5 7) t)
(set-LOC-occ (GRID-ref grid2 8 8) t)

;; Starting and goal locations for problem 2
(setq start2 (make-coord 1 1))

(setq goal2-1 (make-coord 4 7))
(setq goal2-2 (make-coord 8 3))
(setq goal2-3 (make-coord 7 8))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GRID 3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(setq grid3 (make-grid 10 10))

;; Grid 2 should have the following representation
;;
;; 
;; 9 + + + + + + + + + +
;; 8 + X + + + + + + X +
;; 7 X + X X X X X X + +
;; 6 + X + + + + + + + +
;; 5 + + + + + + X + + +
;; 4 + + + + + + + + + +
;; 3 + + + + + + + + + +
;; 2 + + + + + + + + + +
;; 1 + + + + + + + + + +
;; 0 + + + + + + + + + +
;;   0 1 2 3 4 5 6 7 8 9

;; Add obstacles to grid 3
(set-LOC-occ (GRID-ref grid3 6 5) t)
(set-LOC-occ (GRID-ref grid3 0 7) t)
(set-LOC-occ (GRID-ref grid3 1 6) t)
(set-LOC-occ (GRID-ref grid3 1 8) t)
(set-LOC-occ (GRID-ref grid3 2 7) t)
(set-LOC-occ (GRID-ref grid3 3 7) t)
(set-LOC-occ (GRID-ref grid3 4 7) t)
(set-LOC-occ (GRID-ref grid3 5 7) t)
(set-LOC-occ (GRID-ref grid3 6 7) t)
(set-LOC-occ (GRID-ref grid3 7 7) t)
(set-LOC-occ (GRID-ref grid3 8 8) t)

;; Starting and goal locations for problem 3
(setq start3 (make-coord 1 1))

(setq goal3-1 (make-coord 4 5))
(setq goal3-2 (make-coord 7 8))
(setq goal3-3 (make-coord 0 8))
(setq goal3-4 (make-coord 1 7))
(setq goal3-5 (make-coord 6 6))

(setq goals3-1 (list (make-coord 4 5) (make-coord 7 8)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GRID E for extra credit question
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Grid e should have the following representation
;;
;; 4 + + + + +
;; 3 + X + X +
;; 2 + X + X +
;; 1 + X X X +
;; 0 + + + + +
;;   0 1 2 3 4 

(setq grid-e (make-grid 5 5))

(set-LOC-occ (GRID-ref grid-e 1 1) t)
(set-LOC-occ (GRID-ref grid-e 2 1) t)
(set-LOC-occ (GRID-ref grid-e 3 1) t)
(set-LOC-occ (GRID-ref grid-e 1 2) t)
(set-LOC-occ (GRID-ref grid-e 1 3) t)
(set-LOC-occ (GRID-ref grid-e 3 2) t)
(set-LOC-occ (GRID-ref grid-e 3 3) t)
